extern long BufferSize;
extern char *Buffer,*LNStrings;
extern BOOL BufferChange;
extern struct Node *BufferLN;
extern struct MinList BufferList;
extern struct Window *Wnd;
extern struct Gadget *CasioLinkGadgets[];
extern struct EasyStruct Error,SicherReq;
extern struct IntuiText IText[];
extern struct Konfig Konf;

char Dir[100],Datei[40],FullName[140],Pattern[40] = "~(#?.info)";

void Retrive()
{
  long zeilen=0,BufOff=0,CRLF=0;
  char zeichen;
  BPTR FileHandle;

  if(!(FileHandle = Open((UBYTE *)FullName, MODE_OLDFILE)))
  {
    EasyRequest(Wnd, &Error, NULL, "Laden", "Datei kann nicht geffnet werden.");
    return;
  }

  BufferLoeschen();

  while(zeichen != EOF)
  {
    zeichen=FGetC(FileHandle);
    switch(zeichen)
    {
      case CR : CRLF++;
                break;
      case LF : CRLF--;
                Buffer[BufOff++] = CR;
                Buffer[BufOff++] = LF;
                zeilen++;
                break;
      default : for(;CRLF>0;CRLF--)      /* da das letzte Zeichen immer ein */
                {                        /* 0xFF ist, wird default am Ende  */
                  Buffer[BufOff++] = CR; /* einer Datei nocheinmal durchl.  */
                  Buffer[BufOff++] = LF;
                  zeilen++;
                }
                Buffer[BufOff++] = zeichen;
                CRLF=0;
    }
    if(BufOff > BufferSize)
    {
      EasyRequest(Wnd, &Error, NULL, "Laden", "Buffer ist nicht Gro genug.");
      Close(FileHandle);
      return;
    }
  }

  Close(FileHandle);

  BufOff -=2;
  if(Buffer[BufOff++] != LF)
  {
    Buffer[BufOff++] = CR;
    Buffer[BufOff++] = LF;
    zeilen++;
  }
  Buffer[BufOff] = 0;

  MakeList(BufOff, zeilen);
}

void Laden()
{
  struct FileRequester *fr;

  if(BufferChange)
    if(!EasyRequest(Wnd, &SicherReq, NULL, "Buffer ist nicht gesichert!"))
      Speichern();

  if(!(fr = (struct FileRequester *)AllocAslRequestTags(ASL_FileRequest,
                           ASL_Hail,          "Laden",
                           ASL_Dir,          Dir,
                           ASL_File,          Datei,
                           ASL_Pattern,   Pattern,
                           ASL_FuncFlags, FILF_PATGAD,
                           ASL_Window,          Wnd,
                           TAG_DONE))) return;

  if(!AslRequest(fr, NULL))
  {
    FreeAslRequest(fr);      /* Cancel */
    BufferChange = FALSE;
    return;
  }

  strcpy(Pattern, fr->rf_Pat);
  strcpy(Dir, fr->rf_Dir);
  strcpy(Datei, fr->rf_File);
  strcpy(FullName, Dir);
  AddPart((UBYTE *)FullName, (UBYTE *)Datei, 120);
  FreeAslRequest(fr);

  Retrive();
}

void Speichern()
{
  long BufOff=0;
  char zeichen;
  BPTR FileHandle;
  struct FileRequester *fr;

  if(!(fr = (struct FileRequester *)AllocAslRequestTags(ASL_FileRequest,
                           ASL_Hail,          "Speichern",
                           ASL_Dir,          Dir,
                           ASL_File,          Datei,
                           ASL_Pattern,   Pattern,
                           ASL_FuncFlags, FILF_PATGAD|FILF_SAVE,
                           ASL_Window,          Wnd,
                           TAG_DONE))) return;

  if(!AslRequest(fr, NULL))
  {
    FreeAslRequest(fr);      /* Cancel */
    return;
  }

  strcpy(Pattern, fr->rf_Pat);
  strcpy(Dir, fr->rf_Dir);
  strcpy(Datei, fr->rf_File);
  strcpy(FullName, Dir);
  AddPart((UBYTE *)FullName, (UBYTE *)Datei, 120);
  FreeAslRequest(fr);
  PrintGadStr(GD_Datei, Datei);

  if(!(FileHandle = Open((UBYTE *)FullName, MODE_NEWFILE)))
  {
    EasyRequest(Wnd, &Error, NULL, "Speichern", "Kein Zugriff mglich.");
    return;
  }

  while(Buffer[BufOff])
  {
    zeichen=Buffer[BufOff++];
    if((zeichen == LF)&&(Konf.CRLF == 1)) continue;
    if((zeichen == CR)&&(Konf.CRLF == -1)) continue;
    FPutC(FileHandle, (ULONG)zeichen);
  }

  Close(FileHandle);

  BufferChange = FALSE;
}

void Drucken()
{
  long BufOff=0;
  ULONG zeichen;
  BPTR FileHandle;

  PrintGadStr(GD_Status, "Datei wird zum Drucker bertragen.");
  if(!(FileHandle = Open((UBYTE *)"PRT:", MODE_NEWFILE)))
  {
    EasyRequest(Wnd, &Error, NULL, "Drucken", "Kein Zugriff mglich.");
    PrintGadStr(GD_Status, "Kein Zugriff auf den Drucker.");
    return;
  }

  while(Buffer[BufOff])
  {
    zeichen=Buffer[BufOff++];
    if(zeichen == CR) continue;
    if(FPutC(FileHandle, zeichen) == EOF)    /* Anmerkung beachten */
    {
      EasyRequest(Wnd, &Error, NULL, "Drucken", "User-Abbruch");
      Close(FileHandle);
      PrintGadStr(GD_Status, "bertragung zum Drucker abgebrochen.");
      return();
    }
  }

  Close(FileHandle);
  PrintGadStr(GD_Status, "bertragung zum Drucker erfolgreich beendet.");
}

void MakeList(long BufOff, long zeilen)
{
  long i;

  PrintBytes(BufOff);

  BufferLN = AllocVec(zeilen * sizeof(struct Node), MEMF_ANY|MEMF_CLEAR);
  LNStrings = AllocVec(BufOff, MEMF_ANY|MEMF_CLEAR);
  if((!BufferLN)||(!LNStrings))
  {
    FreeVec(BufferLN);
    BufferLN = 0;
    FreeVec(LNStrings);
    LNStrings = 0;
    PrintGadStr(GD_Status, "Nicht genug Speicher frei!");
    return();
  }
  CopyMem(Buffer, LNStrings, BufOff);

  BufOff = 0;
  for(i=0;i<zeilen;i++)
  {
    BufferLN[i].ln_Name = &LNStrings[BufOff];
    BufferLN[i].ln_Succ = &BufferLN[i+1];
    BufferLN[i].ln_Pred = &BufferLN[i-1];
    for(;LNStrings[BufOff]!=CR;BufOff++);
    LNStrings[BufOff++] = 0;
    LNStrings[BufOff++] = 0;
  }
  BufferLN[zeilen-1].ln_Succ = (struct Node*)&BufferList.mlh_Tail;
  BufferLN[0].ln_Pred = (struct Node*)&BufferList.mlh_Head;
  BufferList.mlh_Head = (struct MinNode*)&BufferLN[0];
  BufferList.mlh_TailPred = (struct MinNode*)&BufferLN[zeilen-1];

  PrintGadStr(GD_Datei, Datei);
  GT_SetGadgetAttrs(CasioLinkGadgets[GD_BufferListe], Wnd, NULL,
                    GTLV_Labels, &BufferList, TAG_DONE);
}

/* Anmerkung :
   Die DOS-Funktion FPutC() gibt ein EOF zurck, wenn der Benutzer
   beim Trouble-Printer Requester ein Abbruch whlt.
   (So ist es auch im RKRM Includes and Autodocs, 3.Auflage, S.74
   beschrieben)
   Aber in den Includes ist die Funktion als
   VOID FPutC( BPTR fh, unsigned long ch );
   deklariert.
   (RKRM Includes and Autodocs, S.597, 2.Hlfte, Zeile 102)
   Damit das Programm ordentlich compiliert wird, sollte die
   Deklaration so aussehen:
   long FPutC( BPTR fh, unsigned long ch );
   Unter OS2.04 V37 funktioniert es, aber da ich nicht wei, welche
   der beiden Definitionen richtig ist, ist hier Vorsicht geboten!
   */

/* The DOS-Function FPutC() returns an EOF, if the User selects the
   CANCEL-Button of the Trouble-Printer requester.
   (see also RKRM Includes and Autodocs, 3.Edition, Page 74)
   But in the official Includes the function is declared as:
   VOID FPutC( BPTR fh, unsigned long ch );
   (RKRM Includes and Autodocs, Page 597, Part2, Zeile 102)
   For a correct compilation of this program the function must declared
   as followed:
   long FPutC( BPTR fh, unsigned long ch );
   under OS2.04 (V37) it works, but I don't know which is the right
   declaration, so be carefull!
   */