
/* defines fr CasioLink-Projekt */

#include <functions.h>
#include <stat.h>
#include <stdio.h>
#include <devices/serial.h>
#include <exec/memory.h>
#include <libraries/asl.h>
#include <intuition/gadgetclass.h>
#include <intuition/intuition.h>

#define KONFNAME    "ENV:CasioLink/CasioLink.prefs"
#define KONFARCNAME "ENVARC:CasioLink/CasioLink.prefs"
#define CR 13
#define LF 10

void BufferLoeschen();
void ChangeState();
void CleanUp();
void CloseDownScreen();
void CloseKonfigWindow();
void CloseKonf2Window();
void CloseWind();
void Drucken();
void Empfangen();
void Hilfe();
void Konf_Laden(char *DateiName);
void Konf_RS232();
void Konf_Sonst();
void Konf_Speichern(char *DateiName);
void Laden();
void Loeschen();
void MakeList(long BufOff, long zeilen);
BOOL MenuAction();
long OpenKonfigWindow();
long OpenKonf2Window();
long OpenLib();
long OpenWind();
void PrintBytes(long bytes);
void PrintGadStr(long nr, char *Str);
void Retrive();
void Senden();
void SerOpen();
long SetRS232();
long SetupScreen();
void ShowBaudrate();
void Speichern();
void UpdateParameter();

struct Konfig {
   long Baudrate;      /* RS232         */
   WORD Bytes;               /* RS232 (7,8)   */
   BYTE Paritaet;      /* RS232 (N,E,O) */
   BYTE StoppBits;     /* RS232 (1,2)   */
   BOOL XONXOFF;       /* RS232         */
   BYTE CRLF;               /* Speichern (-1=LF,0=LFCR,1=CR) */
   WORD Unit;               /* Unitnummer des (serial).device */
   WORD Timeout;       /* RS232 */
   WORD BufferSize;    /* InputBuffer (in KBytes) */
   char *Editor;
   char *Shell;
   char *Device;
   };

/* Konf_RS.h */

#define GD_Baud6      0
#define GD_Baud5      1
#define GD_Baud4      2
#define GD_Baud3      3
#define GD_Baud2      4
#define GD_Baud1      5
#define GD_BpB8       6
#define GD_BpB7       7
#define GD_Par_N      8
#define GD_Par_O      9
#define GD_Par_E     10
#define GD_Stop2     11
#define GD_Stop1     12
#define GD_XON_an    13
#define GD_XON_Aus   14
#define GD_Save      15
#define GD_Use       16
#define GD_Cancel    17
#define GD_Baud9     18
#define GD_Text0     19
#define GD_Text1     20
#define GD_Text2     21
#define GD_Text3     22
#define GD_Text4     23
#define GD_Text5     24

#define Konfig_CNT 25

/* Konf_Sonst.h */

#define GD_Line_0    0
#define GD_Line_1    1
#define GD_Line_2    2
#define GD_Save2     3
#define GD_Use2      4
#define GD_Cancel2   5
#define GD_Unit      6
#define GD_Timeout   7
#define GD_Buffer    8
#define GD_Editor    9
#define GD_Shell    10
#define GD_Device   11
#define GD_Text10   12

#define Konf2_CNT 13

/* Layout.h */

#define GD_Speichern    0
#define GD_Laden        1
#define GD_Senden       2
#define GD_Empfangen    3
#define GD_Loeschen     4
#define GD_Konf_RS      5
#define GD_Konf_Sonst   6
#define GD_bytes        7
#define GD_Status       8
#define GD_Parameter    9
#define GD_Datei       10
#define GD_BufferListe 11

#define CasioLink_CNT 12
