extern long BufferSize;
extern char *Buffer,Datei[];
extern BOOL SerOK,BufferChange;
extern struct EasyStruct SicherReq;
extern struct MsgPort  *SerialMP;
extern struct IOExtSer *SerialIO;
extern struct Konfig Konf;
extern struct Window *Wnd;
extern struct Gadget *CasioLinkGadgets[];

void SerOpen()
{
  if(SerOK) CloseDevice((struct IORequest *)SerialIO);
  DeleteIORequest((struct IORequest *)SerialIO);
  DeleteMsgPort(SerialMP);

  if(!(SerialMP=CreateMsgPort())) goto SERERROR;
  if(!(SerialIO=(struct IOExtSer *) CreateIORequest(SerialMP,sizeof(struct IOExtSer)))) goto SERERROR;
  if(OpenDevice((STRPTR)Konf.Device,(long)Konf.Unit,
                (struct IORequest *)SerialIO,0)) goto SERERROR;

  GT_SetGadgetAttrs(CasioLinkGadgets[GD_Senden], Wnd, NULL, GA_Disabled, FALSE, TAG_DONE);
  GT_SetGadgetAttrs(CasioLinkGadgets[GD_Empfangen], Wnd, NULL, GA_Disabled, FALSE, TAG_DONE);
  SerOK = TRUE;
  return();

SERERROR:
  GT_SetGadgetAttrs(CasioLinkGadgets[GD_Senden], Wnd, NULL, GA_Disabled, TRUE, TAG_DONE);
  GT_SetGadgetAttrs(CasioLinkGadgets[GD_Empfangen], Wnd, NULL, GA_Disabled, TRUE, TAG_DONE);
  SerOK = FALSE;
}

long SetRS232()
{
  SerialIO->io_Baud = Konf.Baudrate;
  SerialIO->io_ReadLen = Konf.Bytes;
  SerialIO->io_WriteLen = Konf.Bytes;
  SerialIO->io_StopBits = Konf.StoppBits;
  SerialIO->io_SerFlags = (Konf.XONXOFF) ? 0 : SERF_XDISABLED;
  SerialIO->io_SerFlags |= (Konf.Paritaet == 'O') ? SERF_PARTY_ODD : 0;
  SerialIO->io_SerFlags |= (Konf.Paritaet == 'N') ? 0 : SERF_PARTY_ON;
  SerialIO->IOSer.io_Command  = SDCMD_SETPARAMS;
  if(DoIO((struct IORequest *)SerialIO))
  {
    PrintGadStr(GD_Status, "Fehlerhafte Parameter!");
    return(1);
  }
  return(0);
}

void Senden()
{
  long Bytes,ctr;

  if(SetRS232()) return();

  for(Bytes=0;Buffer[Bytes];Bytes++);
  for(ctr=0;ctr < Bytes;ctr++)
    if(Buffer[ctr] == '') Buffer[ctr] = 0x89; /*  in beta-zeichen wandeln */

  SerialIO->IOSer.io_Length   = Bytes;
  SerialIO->IOSer.io_Data     = (APTR)Buffer;
  SerialIO->IOSer.io_Command  = CMD_WRITE;

  PrintGadStr(GD_Status, "bertragung beginnt");
  if(DoIO((struct IORequest *)SerialIO)) PrintGadStr(GD_Status, "Timeout !");
  else PrintGadStr(GD_Status, "bertragung beendet.");
  for(ctr=0;ctr < Bytes;ctr++)
    if((UBYTE)Buffer[ctr] == 0x89) Buffer[ctr] = ''; /* beta-zeichen in  wandeln */
}

void Empfangen()
{
  long oldBytes=0,TimeOut=0,ctr,zeilen=0;

  if(SetRS232()) return();
  if(BufferChange)
    if(!EasyRequest(Wnd, &SicherReq, NULL, "Buffer ist nicht gesichert!"))
      return();
  Datei[0] = 0;
  BufferLoeschen();

  SerialIO->IOSer.io_Command  = CMD_CLEAR;
  DoIO((struct IORequest *)SerialIO);

  SerialIO->IOSer.io_Length   = BufferSize;
  SerialIO->IOSer.io_Data     = (APTR)Buffer;
  SerialIO->IOSer.io_Command  = CMD_READ;
  SendIO((struct IORequest *)SerialIO);
  PrintGadStr(GD_Status, "bertragung beginnt");

  while(TimeOut < Konf.Timeout*2)
  {
     Delay(25);
     if((SerialIO->IOSer.io_Actual) != oldBytes)
     {
        oldBytes = SerialIO->IOSer.io_Actual;
        TimeOut = (Konf.Timeout-1)*2;
     }
     TimeOut++;
  }

  if(!oldBytes)
  {
    AbortIO((struct IORequest *)SerialIO);
    WaitIO((struct IORequest *)SerialIO);
    PrintGadStr(GD_Status, "Timeout !");
    return();
  }

  PrintGadStr(GD_Status, "bertragung beendet.");
  if(Buffer[oldBytes-1] != LF)
  {
    Buffer[oldBytes++] = CR;
    Buffer[oldBytes++] = LF;
    Buffer[oldBytes] = 0;
  }

  AbortIO((struct IORequest *)SerialIO);
  WaitIO((struct IORequest *)SerialIO);

  for(ctr=0;ctr < oldBytes;ctr++)
  {
    if(Buffer[ctr] == LF) zeilen++;
    if((UBYTE)Buffer[ctr] == 0x89) Buffer[ctr] = ''; /* beta-zeichen in  wandeln */
  }
  MakeList(oldBytes, zeilen);
  BufferChange = TRUE;
}
